program elemental
   use mpi
   INTEGER,PARAMETER :: wp = selected_real_kind(12, 307)
   integer :: ierr
   integer :: array_size = 100
   integer :: ii,jj                                ! dummy integers
   real(wp) , allocatable, dimension(:,:) :: A,B,C ! Arrays
   real(wp) :: pa,pb,pc                            ! Parameters
   


   allocate(A(array_size,array_size))
   allocate(B(array_size,array_size))
   allocate(C(array_size,array_size))

   call random_number(A)
   call random_number(B)
   call random_number(C)

   call random_number(pa)
   call random_number(pb)
   call random_number(pc)
   
   call mpi_init(ierr)

   do ii=1,10
   call mpi_barrier(mpi_comm_world,ierr)
      A(:,:) = pa + pb*B(:,:)*C(:,:)
   call mpi_barrier(mpi_comm_world,ierr)
   end do

   call mpi_finalize(ierr)

end program
